<template>
  <div class="tree-left">
    <el-tree :data="data" ref="tree" default-expand-all node-key="id" :expand-on-click-node="false">
      <span
        class="custom-tree-node"
        slot-scope="{ node, data }"
        @mouseenter="mouseenter(data)"
        @mouseleave="mouseleave(data)"
      >
        <span>{{ node.label }}</span>
        <span>
          <el-dropdown
            v-show="data.show"
            @command="
              (command) => {
                handleCommand(command, data)
              }
            "
          >
            <span class="el-dropdown-link">
              <i class="el-icon-more icon"></i>
            </span>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item command="edit">编辑部门</el-dropdown-item>
              <el-dropdown-item command="add">新增子部门</el-dropdown-item>
              <el-dropdown-item v-if="data.id !== 1" command="delete">删除部门</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
        </span>
      </span>
    </el-tree>
  </div>
</template>

<script>
export default {
  name: "TreeLeft",
  props: {},
  components: {},
  computed: {},
  data() {
    const data = [
      {
        id: 1,
        label: "上海灵当信息科技有限公司",
        children: [
          {
            id: 11,
            label: "销售部",
            children: [
              {
                id: 111,
                label: "Mia"
              },
              {
                id: 112,
                label: "系统管理员"
              },
              {
                id: 113,
                label: "销售"
              },
              {
                id: 114,
                label: "销售总监"
              },
              {
                id: 115,
                label: "销售一部",
                children: []
              },
              {
                id: 116,
                label: "销售二部",
                children: []
              }
            ]
          },
          {
            id: 21,
            label: "管理层",
            children: [
              {
                id: 211,
                label: "BOSS"
              },
              {
                id: 212,
                label: "系统管理员"
              }
            ]
          },
          {
            id: 31,
            label: "财务部",
            children: []
          },
          {
            id: 41,
            label: "市场部",
            children: []
          }
        ]
      }
    ]
    return {
      defaultProps: {
        children: "children",
        label: "label"
      },
      data: JSON.parse(JSON.stringify(data))
    }
  },
  created() {},
  methods: {
    mouseenter(data) {
      this.$set(data, "show", true)
    },
    mouseleave(data) {
      this.$set(data, "show", false)
    },
    handleCommand(command, data) {
      this.$emit("editDepartmentClick", command, data)
    }
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style lang="scss" scoped>
.tree-left {
  padding: 20px 10px;
  .custom-tree-node {
    flex: 1;
    display: flex;
    align-items: center;
    justify-content: space-between;
    font-size: 14px;
    padding-right: 10px;
    height: 100%;
    .icon {
      transform: rotate(90deg);
    }
  }
}
</style>
